using System.Text.RegularExpressions;

namespace Ocelot.Values
{
    public class UpstreamPathTemplate
    {
        public UpstreamPathTemplate(string template, int priority, bool containsQueryString, string originalValue)
        {
            Template = template;
            Priority = priority;
            ContainsQueryString = containsQueryString;
            OriginalValue = originalValue;
            Pattern = template == null ? 
                new Regex("$^", RegexOptions.Compiled | RegexOptions.Singleline) : 
                new Regex(template, RegexOptions.Compiled | RegexOptions.Singleline);
        }

        public string Template { get; }

        public int Priority { get; }

        public bool ContainsQueryString { get; }

        public string OriginalValue { get; }
        
        public Regex Pattern { get; }
    }
}
